flags_t flags = {false, false, false, false, false, false,
                 {-1, -1}};
struct winsize win;

int
main(int argc, char **argv) {

    if (argc > 1) {
        get_flags(argv);
        if (flags.error[0] != -1) {
            ft_printf_fd(2, "ft_ls: invalid option -- \'%s\'\n",
                         &argv[flags.error[0]][flags.error[1]]);
            return 2;
        }
    }

    ioctl(STDOUT_FILENO, TIOCGWINSZ, &win);
    errno = 0;

    t_list **files = ft_calloc(ft_strslen(argv) + 1, sizeof(t_list*));
    t_list **dirs = ft_calloc(ft_strslen(argv) + 1, sizeof(t_list*));
    i32 max_size = 0, len = 0, error = 0;
    parsing(argv, &files, &dirs, &max_size, &len, &error);

    if (len == 0 && error == 0)
        add_sort(dirs, get_directory_files("."), true);

    i32 left = len;
    if (ft_lstsize(*files) > 0)
        left -= display_files(files);
    free_files(files);

    if (left != len && left > 0)
        ft_printf("\n");

    for (t_list *cur = *dirs; cur != nullptr; cur = cur->next) {
        dir_t *dir = (dir_t*)cur->content;
        if (len > 1 && !flags.R)
            ft_printf("%s:\n", dir->path);
        display_directory(dir);
        if (left > 1)
            ft_printf("\n");
        left--;
    }
    free_files(dirs);

    return error;
}
